<?php
/*
Plugin Name:  FS Tell a Friend
Plugin URI: https://www.fastsheep.com/wordpress-plugins-support/fs-tell-a-friend-wordpress-plugin/
Description: FS Tell a Friend - produces message lightbox to send visited page URL to a friend.
Requires at least: 4.7
Tested up to: 4.9
Version: 2.0
Author URI: Vlad Madejczyk, http://www.fastsheep.com
*/

 /* Copyright (c) 2018 Vlad Madejczyk,  (email: info@fastsheep.com)
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/


$fstaf_main_file = dirname(__FILE__) . '/fstaf-main.php';

define( 'VLADFSTAF_PLUGIN_PATH_SLASH', plugin_dir_url( $fstaf_main_file ) );
define( 'VLADFSTAF_PLUGIN_DIR_PATH_SLASH', plugin_dir_path( __FILE__ ) );


function fastsheep_fstaf_activation() {

    include_once( VLADFSTAF_PLUGIN_DIR_PATH_SLASH . 'inc/fs-ac-taf.php' );

    $fstaf_installed_ver = get_option( "fastsheep_fstaf_version" );

    if ( $fstaf_installed_ver == '' ) {
      fastsheep_fstaf_createTaFtables();
      update_option( "fastsheep_fstaf_version", "1.0" );
      update_option( "fastsheep_fstaf_manage_slug", "fastsheep-fstaf-management" );
    }

}

function fastsheep_fstaf_deactivation() {

}

add_action( 'admin_menu', 'fastsheep_fstaf_create_menu' );
function fastsheep_fstaf_create_menu() {

    if ( !current_user_can( 'manage_options' ) )  {
        wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
    }

add_menu_page('FS Tell a Friend', 'FS TaF', 'manage_options', 'fstaf-dashboard', 'fastsheep_fstaf_menu_dashboard_page', VLADFSTAF_PLUGIN_PATH_SLASH . 'images/fs-taf-menu-icon.png' );

}

function fastsheep_fstaf_menu_dashboard_page() {

 require_once( VLADFSTAF_PLUGIN_DIR_PATH_SLASH . 'inc/fs-taf-dashboard.php' );

}


class fastsheep_fstaf_widget_basic extends WP_Widget {

    function __construct() {

        parent::__construct(

                'fastsheep_fstaf_widget_basic',

                __('FS TaF Widget Basic', 'fastsheep_fstaf_widget_basic_domain'),

                array( 'description' => __( 'Description of widget: FS TaF widget basic', 'fastsheep_fstaf_widget_basic_domain' ), )
            );

    }


    public function widget( $args, $instance ) {

        $fstaf_widget_basic_output = fastsheep_fstaf_basic_shortcode_function();

        echo __( $fstaf_widget_basic_output, 'fastsheep_fstaf_widget_basic_domain' );

    }

}


function fastsheep_fstaf_load_widget_basic() {
	register_widget( 'fastsheep_fstaf_widget_basic' );
}
add_action( 'widgets_init', 'fastsheep_fstaf_load_widget_basic' );


class fastsheep_fstaf_widget_special extends WP_Widget {

    function __construct() {

        parent::__construct(

                'fastsheep_fstaf_widget_special',

                __('FS TaF Widget Special', 'fastsheep_fstaf_widget_special_domain'),

                array( 'description' => __( 'Description of widget: FS TaF widget special', 'fastsheep_fstaf_widget_special_domain' ), )
            );

    }


    public function widget( $args, $instance ) {

        $fstaf_widget_special_output = fastsheep_fstaf_special_shortcode_function();

        echo __( $fstaf_widget_special_output, 'fastsheep_fstaf_widget_special_domain' );

    }

}


function fastsheep_fstaf_load_widget_special() {

	register_widget( 'fastsheep_fstaf_widget_special' );

}
add_action( 'widgets_init', 'fastsheep_fstaf_load_widget_special' );


function fastsheep_fstaf_getAffPHPversion() {

    list($v1,$v2) = explode('.', phpversion() );
    return $v1 . $v2;

}


register_activation_hook(__FILE__,'fastsheep_fstaf_activation');
register_deactivation_hook(__FILE__,'fastsheep_fstaf_deactivation');


include_once( VLADFSTAF_PLUGIN_DIR_PATH_SLASH . 'inc/fs-ajx-taf.php' );
include_once( VLADFSTAF_PLUGIN_DIR_PATH_SLASH . 'inc/fs-fcts-taf.php' );

?>
