<?php
if ( ! defined( 'ABSPATH' ) ) exit;


function fastsheep_fstaf_createTaFtables() {

    global $wpdb;
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

    $table_data = $wpdb->prefix . "fastsheep_fstaf_data";

    $sqlstats = "CREATE TABLE IF NOT EXISTS $table_data (
        `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
	    `meta_key` varchar(128) NOT NULL,
        `meta_value` longtext,
        PRIMARY KEY (`ID`),
        UNIQUE KEY `meta_key` (`meta_key`)
    ) ENGINE=InnoDB $charset_collate;";

    dbDelta( $sqlstats );

	$em_obj = new stdClass();
	$total_emails_count_obj = serialize( $em_obj );

	$fstaf_tzone = get_option('timezone_string');
	if( $fstaf_tzone != '' ) { date_default_timezone_set( $fstaf_tzone ); }

		$wpdb->insert(
		$table_data,
		array(
			'meta_key' => 'emails_count_obj',
			'meta_value' => $total_emails_count_obj,
			)
		);

		$wpdb->insert(
		$table_data,
		array(
			'meta_key' => 'emails_count_obj_ut',
			'meta_value' => time()
			)
		);


	$default_settings = array(
		'set_lightbox_title' => 'Send the page address to your friend!',
		'set_email_subject' => 'Please visit this page',
		'set_button_text' => 'Send to Friend',
		'set_widget_shortcode_text' => 'Tell a Friend',
		'set_use_graphic_button' => 'no',
		'set_graphic_button_url' => ''
		);

	$special_settings = array(
		'set_lightbox_title' => 'Send the page address to your friend!',
		'set_email_subject' => 'Please visit this page',
		'set_button_text' => 'Send to Friend',
		'set_widget_shortcode_text' => 'Tell a Friend',
		'set_use_graphic_button' => 'no',
		'set_graphic_button_url' => '',
		'set_special_url' => home_url()
		);

	$settings_basic_default_array = $default_settings;
	$settings_basic_default = serialize( $settings_basic_default_array );
	$settings_basic_user = $settings_basic_default;

	$settings_special_default_array = $special_settings;
	$settings_special_default = serialize( $settings_special_default_array );
	$settings_special_user = $settings_special_default;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'settings_basic_default',
		'meta_value' => $settings_basic_default
		)
	);

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'settings_basic_user',
		'meta_value' => $settings_basic_user
		)
	);

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'settings_special_default',
		'meta_value' => $settings_special_default
		)
	);

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'settings_special_user',
		'meta_value' => $settings_special_user
		)
	);

$css_basic_default = '

#fastsheep_fstaf_bg  {
/* ID of box background */
 }

.fstellafriend_background {
/*the grey background class */
	display: none;
	position: fixed;
	top: 0%;
	left: 0%;
	width: 100%;
	height: 100%;
	background-color: black;
	z-index:9999;
	background: rgba(0, 0, 0, 0.7);
 }

#fstellafriend_message_box {
/*the message box ID */

}

.fstellafriend_box {
/*the message box class */
	display: none;
	position: fixed;
	top: 50%;
	left: 50%;
	width: 300px;
	height: 520px;
	/*margin: -260px 0 0 -260px;*/
	margin-top:-260px;
	margin-left:-160px;
	padding: 10px;
	border: 2px solid #8AC007;
	border-radius: 5px;
	background-color: white;
	z-index:10000;
	overflow: auto;
 }

#fastsheep_fstaf_title {
/*ID of message box title */
	text-align: center;
	margin-bottom:10px;
	font-family:Arial;
	font-weight: bold;
 }

#fastsheep_fstaf_page_url {
	padding:5px;
	margin-bottom:15px;
	border:dotted 1px;
	white-space:nowrap;
	overflow-x:scroll;
}

#fastsheep_fstaf_message_form {
/*ID of message box form*/

 }

#fastsheep_fstaf_your_name {

 }

#fastsheep_fstaf_your_email {

 }

#fastsheep_fstaf_your_friend_name {

 }

#fastsheep_fstaf_your_friend_email {

 }

#fastsheep_fstaf_send {
	width: 100%;
	height: 40px;
	font-size: 1.0em;
	font-weight: bold;
	border-radius: 4px;
	position: relative;
	margin: 0 auto;
	display: block;
	top: -10px;
	background-color: #003399;
 }

.fastsheep_fstaf_input {
	display: block;
	font-family: Arial;
	font-size: 16px;
	height: 42px;
	margin: 0 auto 10px;
	position: relative;
	width: 240px;
}

#fastsheep_fstaf_send:hover {
/*hover of send button*/
 	background-color: #8AC007;
 }

#fastsheep_fstaf_captcha {
/*ID of captcha box*/
	top: -25px;
	position: relative;
	text-align: left;
 }

#fastsheep_fstaf_c1 {
/*ID of first captcha number */
	width:40px;
	margin-top:30px;
}

#fastsheep_fstaf_c2 {
/*ID of captcha operand */
	width:40px;
	margin-top:30px;
 }

#fastsheep_fstaf_c3 {
/*ID of second captcha number */
	width:40px;
	margin-top:30px;
 }

#fastsheep_fstaf_c4 {
/*ID of captcha result */
	width:45px;
	height:37px;
	margin-top:30px;
 }

#fastsheep_fstaf_feedbackmsg {
	position:relative;
	margin-left:15px;
	text-align:center;
	display:none;
}

#fastsheep_fstaf_widget_holder {
/*ID of widget holder */

}

#fastsheep_fstaf_image_widget {

}

#fastsheep_fstaf_text_widget {

}

#fastsheep_fstaf_captcha_error_field {
/*ID of captcha error message*/

}

#fastsheep_fstaf_error_field {
/*ID of error message*/
	display:none;
	color:#FF0000;
}

#fastsheep_fstaf_success_field {
/*ID of success message*/
	display:none;
  }

#fastsheep_fstaf_inputs {

}

#fastsheep_fstaf_close_x {
	text-align:right;
	top: 20px;
	position: relative;
	cursor: pointer;
	cursor: hand;
}

#fastsheep_fstaf_thank_you {
    display:none;
    text-align:center;
}
#activate_lem_box {
	cursor: pointer;
	cursor: hand;
	font-weight:bold;
}

#activate_lem_box_s {
	cursor: pointer;
	cursor: hand;
}

#activate_lem_box_w {
	cursor: pointer;
	cursor: hand;
}

#activate_lem_box_ws {
	cursor: pointer;
	cursor: hand;
}
#fastsheep_fstaf_graphic_button {

}

#fastsheep_fstaf_progressingbar {
	display:none;
	height:24px;
}

';

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'css_basic_default',
		'meta_value' => $css_basic_default
		)
	);

	$css_basic_user = $css_basic_default;
	$css_basic_user = $css_basic_user;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'css_basic_user',
		'meta_value' => $css_basic_user
		)
	);


	$css_special_default = $css_basic_default;
	$css_special_default = $css_special_default ;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'css_special_default',
		'meta_value' => $css_special_default
		)
	);

	$css_special_user = $css_basic_default;
	$css_special_user = $css_special_user;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'css_special_user',
		'meta_value' => $css_special_user
		)
	);


$email_basic_default_tpl = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="format-detection" content="telephone=no">
<title>{set_email_subject}</title>
<style type="text/css">
body {
  margin: 0;
  padding: 0;
  -ms-text-size-adjust: 100%;
  -webkit-text-size-adjust: 100%;
}
table {
  border-spacing: 0;
}
table td {
  border-collapse: collapse;
}
.ExtClass {
  width: 100%;
}
.ExtClass,
.ExtClass p,
.ExtClass span,
.ExtClass font,
.ExtClass td,
.ExtClass div {
  line-height: 100%;
}

table {
  mso-table-lspace: 0pt;
  mso-table-rspace: 0pt;
}
img {
  -ms-interpolation-mode: bicubic;
}

@media screen and (max-width: 599px) {
  table[class="force-row"],
  table[class="container"] {
    width: 100% !important;
    max-width: 100% !important;
  }
}
@media screen and (max-width: 400px) {
  td[class*="container-padding"] {
    padding-left: 12px !important;
    padding-right: 12px !important;
  }
}
</style>

</head>
<body style="margin:0; padding:0;" bgcolor="#FFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">

      <table border="0" width="600" cellpadding="0" cellspacing="0" class="container" style="width:600px;max-width:600px">
        <tr>
          <td class="container-padding header" align="left" style="font-family:Arial, sans-serif;font-size:24px;font-weight:bold;padding-bottom:12px;padding-left:24px;padding-right:24px">
          </td>
        </tr>
        <tr>
          <td class="container-padding content" align="left" style="padding-left:24px;padding-right:24px;padding-top:12px;padding-bottom:12px;background-color:#ffffff">

        <div class="body-text" style="font-family:Arial, sans-serif;font-size:20px;line-height:20px;text-align:left;color:#666666">
Hello {fastsheep_fstaf_friend_name},
        </div>
<br><br>
        <div class="body-text" style="font-family:Arial, sans-serif;font-size:14px;line-height:20px;text-align:left;color:#333333">
        I have found interesting page/ post, please see  the link below:
        <br><br>
        <a href="{fastsheep_fstaf_pageurl}" target="_blank">{fastsheep_fstaf_pageurl}</a>
        <br><br>
best regards<br>
{fastsheep_fstaf_sender_name}
        </div>
          </td>
        </tr>
        <tr>
          <td class="container-padding footer-text" align="left" style="font-family:Arial, sans-serif;font-size:12px;line-height:16px;color:#aaaaaa;padding-left:24px;padding-right:24px"> </td>
        </tr>
      </table>

</body>
</html>';

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'email_basic_default_tpl',
		'meta_value' =>  $email_basic_default_tpl
		)
	);

	$email_basic_user_tpl = $email_basic_default_tpl;
	$email_basic_user_tpl = $email_basic_user_tpl ;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'email_basic_user_tpl',
		'meta_value' => $email_basic_user_tpl
		)
	);


	$email_special_default_tpl = $email_basic_default_tpl;
	$email_special_default_tpl = $email_special_default_tpl ;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'email_special_default_tpl',
		'meta_value' => $email_special_default_tpl
		)
	);

	$email_special_user_tpl = $email_basic_default_tpl;
	$email_special_user_tpl = $email_special_user_tpl;

	$wpdb->insert(
	$table_data,
	array(
		'meta_key' => 'email_special_user_tpl',
		'meta_value' => $email_special_user_tpl
		)
	);

}

?>
