<?php
if ( ! defined( 'ABSPATH' ) ) exit;

function fastsheep_fstaf_ajax_process_request_e() {


	if ( ! isset( $_POST['fastsheep_fstaf_lem_nonce_field'] ) || ! wp_verify_nonce( $_POST['fastsheep_fstaf_lem_nonce_field'], 'fs_activate_lem' ) )
		{
	    print 'Sorry, your nonce did not verify.';
	    wp_die();
		}

	if ( ! isset( $_POST['fastsheep_fstaf_task'] ) || $_POST['fastsheep_fstaf_task'] != 'fstafsendmessage' ) { echo 'hello'; wp_die(); }

	$flag_basic = true;

	$b_flag = sanitize_text_field( $_POST['b_flag'] );
	if( $b_flag == '3' ) {
		$flag_basic = false;
	}

	$the_fstaf_page_url = $_POST['fastsheep_fstaf_page_url'];
	$the_fstaf_page_url = esc_url( $the_fstaf_page_url, array('http', 'https') );

	$sender_name = sanitize_text_field( $_POST['fastsheep_fstaf_sender_name'] );
	if( strlen( $sender_name) > 32 ) { echo 'Error: your name is too long'; wp_die(); }
	if( strlen( $sender_name) == 0 ) { echo 'Error: your name is missing'; wp_die(); }

	$sender_email = sanitize_email( $_POST['fastsheep_fstaf_sender_email'] );
	if ( filter_var( $sender_email, FILTER_VALIDATE_EMAIL ) === false ) {
		echo 'Error: your email is invalid';
		wp_die();
	}

	$friends_name = sanitize_text_field( $_POST['fastsheep_fstaf_friends_name'] );
	if( strlen( $friends_name) > 32 ) { echo 'Error: your friend\'s name is too long'; wp_die(); }
	if( strlen( $friends_name) == 0 ) { echo 'Error: your friend\'s name is missing'; wp_die(); }

	$friends_email = sanitize_email( $_POST['fastsheep_fstaf_friends_email'] );
	if ( filter_var( $friends_email, FILTER_VALIDATE_EMAIL ) === false ) {
		echo 'Error: your friend\'s email is invalid';
		wp_die();
	}

	$fs_operand = sanitize_text_field( $_POST['fastsheep_fstaf_c2'] );

	$ops_array = array("+", "-", "x");
	if ( !isset( $_POST['fastsheep_fstaf_c2'] ) || !in_array( $fs_operand , $ops_array ) ) {
		echo 'error';
		wp_die();
	}

	if ( filter_var($_POST['fastsheep_fstaf_c1'], FILTER_VALIDATE_INT) === false ) {
		echo 'error';
		wp_die();
	}
	$fs_number1 = $_POST['fastsheep_fstaf_c1'];

	if ( filter_var($_POST['fastsheep_fstaf_c3'], FILTER_VALIDATE_INT) === false ) {
		echo 'error';
		wp_die();
	}
	$fs_number2 = $_POST['fastsheep_fstaf_c3'];

	if ( filter_var($_POST['fastsheep_fstaf_c4'], FILTER_VALIDATE_INT) === false ) {
		echo 'Wrong captcha result!';
		wp_die();
	}
	$fs_result = $_POST['fastsheep_fstaf_c4'];
	//verify captcha
	if( !fastsheep_fstaf_verify_captcha($fs_number1, $fs_operand, $fs_number2, $fs_result ) ) {
		echo 'Wrong captcha result!';
		wp_die();
	}

	$lem_array = array();

	if( $flag_basic ) {
		$lem_array = fastsheep_fstaf_getUserBasicSettingsData();
	} else {
		$lem_array = fastsheep_fstaf_getUserSpecialSettingsData();

		$the_fstaf_page_url = $lem_array['set_special_url'];
	}

	add_filter( 'wp_mail_content_type', 'fastsheep_fstaf_set_html_mail_content_type' );

	$fstaf_message = fastsheep_fstaf_feed_email_template( $lem_array, $the_fstaf_page_url, $friends_name, $sender_name );

	$fstaf_email_subject = $lem_array['set_email_subject'];
	$sender_local_wordpress = 'noreply@' . $_SERVER['HTTP_HOST'];

	$fstaf_headers[] = 'From: ' . $sender_name . ' <' . $sender_local_wordpress . '>';
	$fstaf_headers[] = 'Reply-To: ' . $sender_name . ' <' . $sender_email . '>';

	$email_result = wp_mail( $friends_email, $fstaf_email_subject, $fstaf_message, $fstaf_headers);

	if( $email_result ) {

		echo 'OK - email has been sent.';

		fastsheep_fstaf_update_stats();

		remove_filter( 'wp_mail_content_type', 'fastsheep_fstaf_set_html_mail_content_type' );
		wp_die();

	}

	else {

		echo 'Error - email has not been sent.';
		remove_filter( 'wp_mail_content_type', 'fastsheep_fstaf_set_html_mail_content_type' );
		wp_die();

	}

	wp_die();

}


function fastsheep_fstaf_ajax_process_request() {

	if ( ! isset( $_POST['fastsheep_fstaf_update_nonce_field'] ) || ! wp_verify_nonce( $_POST['fastsheep_fstaf_update_nonce_field'], 'admin_update_data' ) )
		{
	    print 'Sorry, your nonce did not verify.';
	    wp_die();
		}

    global $wpdb;

  	if ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'sbs' ) {

		$bs_array = array_map('stripslashes', $_POST);

		if( !fastsheep_fstaf_update_settings ( 'settings_basic_user', $bs_array ) )  { echo 'Update error'; } else {
			echo 'successful update';
		}

		wp_die();

	}

	elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'sss' ) {

		$ss_array = array_map('stripslashes', $_POST);
		if( !fastsheep_fstaf_update_settings ( 'settings_special_user', $ss_array ) )  { echo 'Update error'; } else {
			echo 'successful update';
		}

			wp_die();

		}

	elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'setpl' ) {

		$etpl_array = array_map('stripslashes', $_POST);
		if( !fastsheep_fstaf_update_emcss ( 'email_tpl', $etpl_array ) )  { echo 'Update error'; } else {
			echo 'successful update';
		}

		wp_die();

		}


	elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'slcss' ) {

		$lcss_array = array_map('stripslashes', $_POST);
		if( !fastsheep_fstaf_update_emcss ( 'l_css', $lcss_array ) )  { echo 'Update error'; } else {
			echo 'successful update';
		}

		wp_die();

		}

		elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'rstsbs' && isset( $_POST['chkb_confirm_rbds']) && $_POST["chkb_confirm_rbds"]  == 'rbds' ) {

			echo fastsheep_fstaf_get_default_basic_settings();

			wp_die();

			}

		elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'rstsss'  && isset( $_POST['chkb_confirm_rsds']) && $_POST["chkb_confirm_rsds"]  == 'rsds' ) {

			echo fastsheep_fstaf_get_default_special_settings();

			wp_die();

			}

		elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'rstsetpl'  && isset( $_POST['chkb_confirm_rdet']) && $_POST["chkb_confirm_rdet"]  == 'rdet' ) {

			echo fastsheep_fstaf_get_default_basic_etpl();

			wp_die();

			}

		elseif ( isset( $_POST["fastsheep_fstaf_task"] ) && $_POST["fastsheep_fstaf_task"] == 'rstslcss'  && isset( $_POST['chkb_confirm_rdlc']) && $_POST["chkb_confirm_rdlc"]  == 'rdlc' ) {

			echo fastsheep_fstaf_get_default_basic_lcss();

			wp_die();

			}

}

//------------- AJAX FIX REFERENCE -----------------------




//------------ BEGIN AJAX FIX -------------------------------


if ( is_admin() ) {
	add_action('wp_ajax_fastsheep_fstaf_response', 'fastsheep_fstaf_ajax_process_request');
}

	add_action('wp_ajax_fastsheep_fstaf_response_e', 'fastsheep_fstaf_ajax_process_request_e');
	add_action('wp_ajax_nopriv_fastsheep_fstaf_response_e', 'fastsheep_fstaf_ajax_process_request_e');




add_action('wp_print_scripts', 'fastsheep_fstaf_ajax_load_scripts');
function fastsheep_fstaf_ajax_load_scripts() {

	wp_enqueue_script( "ajax-fstafe", VLADFSTAF_PLUGIN_PATH_SLASH . 'js/fs-taf-e.js', array( 'jquery' ) );
	wp_localize_script( 'ajax-fstafe', 'fastsheep_fstaf_e_ajax_script', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );

}

add_action('admin_enqueue_scripts', 'fastsheep_fstaf_admin_enqueue');
function fastsheep_fstaf_admin_enqueue() {

	wp_enqueue_script( "ajax-fstafabcd", VLADFSTAF_PLUGIN_PATH_SLASH . 'js/fs-taf-abcd.js', array( 'jquery' ) );
	wp_localize_script( 'ajax-fstafabcd', 'fastsheep_fstaf_abcd_ajax_script', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );

}


add_shortcode("fastsheep_fstaf_basic", "fastsheep_fstaf_basic_shortcode_handler");

function fastsheep_fstaf_basic_shortcode_handler() {

  $fs_output = fastsheep_fstaf_basic_shortcode_function();

  return $fs_output;

}

function fastsheep_fstaf_basic_shortcode_function() {

	$get_page_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

	$lem_array = array();
	$lem_array = fastsheep_fstaf_getUserBasicSettingsData();

	$fstaf_css_add = fastsheep_fstaf_get_user_lcss_style();

	$fstaf_shortcode_button = $lem_array['set_widget_shortcode_text'];

	if( $lem_array['set_use_graphic_button'] == 'yes' ) {
	$fstaf_shortcode_button = '<image src="' . $lem_array['set_graphic_button_url'] .'" id="fastsheep_fstaf_graphic_button">';
	}

	$fs_output = $fstaf_css_add . "\n" . '<div id="activate_lem_box">' . $fstaf_shortcode_button . '</div>' . "\n";

	$fs_output .= '
	<div class="fstellafriend_background">
	<div id="fstellafriend_message_box" class="fstellafriend_box">';
	$fs_output .= '<div id="fastsheep_fstaf_title">' . $lem_array['set_lightbox_title'] . '</div>';
	$fs_output .= '<div id="fastsheep_fstaf_thank_you"></div>';
	$fs_output .= '<form id="fastsheep_fstaf_lightbox_form" method="post">' . "\n";
	$fs_output .= '<div id="fastsheep_fstaf_page_url"  title="' . $get_page_url . '" >' . $get_page_url . '</div>';
	$fs_output .= wp_nonce_field( 'fs_activate_lem', 'fastsheep_fstaf_lem_nonce_field' ) . "\n";
	$fs_output .= '<input type="hidden" id="b_flag" name="b_flag" value="2">' . "\n";
	$fs_output .= '<input type="text" placeholder="Your name" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_name" name="fastsheep_fstaf_your_name" required>
	<input type="email" placeholder="Your email" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_email" name="fastsheep_fstaf_your_email" required>
	<input type="text" placeholder="Your friend\'s name" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_friend_name" name="fastsheep_fstaf_your_friend_name" required>
	<input type="email" placeholder="Your friend\'s email" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_friend_email" name="fastsheep_fstaf_your_friend_email" required>';
	$fs_output .= '<div id="fastsheep_fstaf_captcha">
	<span id="fastsheep_fstaf_c1"></span> <span id="fastsheep_fstaf_c2"></span> <span id="fastsheep_fstaf_c3"></span> = <input type="text" id="fastsheep_fstaf_c4"><span id="fastsheep_fstaf_feedbackmsg"></span>
	</div>
	<button id="fastsheep_fstaf_send" type="button">' . $lem_array['set_button_text'] . '</button>
	<!-- progressing... -->
    <div id="fastsheep_fstaf_progressingbar"><img src="' . fastsheep_fstaf_get_email_progressing_url() . '"></div>
	<!-- progressing... -->
	</form>
	<div id="fastsheep_fstaf_close_x">Close [x]</div>
	</div>
	</div>
	';

      return $fs_output;
}


add_shortcode("fastsheep_fstaf_special", "fastsheep_fstaf_special_shortcode_handler");

function fastsheep_fstaf_special_shortcode_handler() {

	$fs_output = fastsheep_fstaf_special_shortcode_function();

	return $fs_output;

}

function fastsheep_fstaf_special_shortcode_function() {

	$lem_array = array();
	$lem_array = fastsheep_fstaf_getUserSpecialSettingsData();

	$get_page_url_display = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	$get_page_url = $lem_array['set_special_url'];

	$fstaf_css_add = fastsheep_fstaf_get_user_lcss_style();

	$fstaf_shortcode_button = $lem_array['set_widget_shortcode_text'];

	if( $lem_array['set_use_graphic_button'] == 'yes' ) {
	$fstaf_shortcode_button = '<image src="' . $lem_array['set_graphic_button_url'] .'" id="fastsheep_fstaf_graphic_button">';
	}

	$fs_output = $fstaf_css_add . "\n" . '<div id="activate_lem_box">' . $fstaf_shortcode_button . '</div>' . "\n";
	$fs_output .= '
	<div class="fstellafriend_background">
	<div id="fstellafriend_message_box" class="fstellafriend_box">';
	$fs_output .= '<div id="fastsheep_fstaf_title">' . $lem_array['set_lightbox_title'] . '</div>';
	$fs_output .= '<div id="fastsheep_fstaf_thank_you"></div>';
	$fs_output .= '<form id="fastsheep_fstaf_lightbox_form" method="post">' . "\n";
	$fs_output .= '<div id="fastsheep_fstaf_page_url"  title="' . $get_page_url_display . '" >' . $get_page_url_display . '</div>';
	$fs_output .= wp_nonce_field( 'fs_activate_lem', 'fastsheep_fstaf_lem_nonce_field' ) . "\n";
	$fs_output .= '<input type="hidden" id="b_flag" name="b_flag" value="3">' . "\n";
	$fs_output .= '<input type="text" placeholder="Your name" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_name" name="fastsheep_fstaf_your_name" required>
	<input type="email" placeholder="Your email" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_email" name="fastsheep_fstaf_your_email" required>
	<input type="text" placeholder="Your friend\'s name" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_friend_name" name="fastsheep_fstaf_your_friend_name" required>
	<input type="email" placeholder="Your friend\'s email" class="fastsheep_fstaf_input" id="fastsheep_fstaf_your_friend_email" name="fastsheep_fstaf_your_friend_email" required>';
	$fs_output .= '<div id="fastsheep_fstaf_captcha">
	<span id="fastsheep_fstaf_c1"></span> <span id="fastsheep_fstaf_c2"></span> <span id="fastsheep_fstaf_c3"></span> = <input type="text" id="fastsheep_fstaf_c4"><span id="fastsheep_fstaf_feedbackmsg"></span>
	</div>
	<button id="fastsheep_fstaf_send" type="button">' . $lem_array['set_button_text'] . '</button>
	</form>
	<div id="fastsheep_fstaf_close_x">Close [x]</div>
	</div>
	</div>
	';

	return $fs_output;
}


function fastsheep_fstaf_get_rnd_strings(){
	//inactive
	$ret_array = array();
	$rat_array['random_string'] = sha1(microtime(true).mt_rand(10000,90000));
	return $rat_array;
}

function fastsheep_fstaf_update_settings ( $fstaf_cat = '', $settings_array = '' ) {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	if( $fstaf_cat == 'settings_basic_user' ) {

		$new_array = array();
		$new_array['set_lightbox_title'] = $settings_array['fastsheep_fstaf_input_mbt'];
		$new_array['set_email_subject'] = $settings_array['fastsheep_fstaf_input_es'];
		$new_array['set_button_text'] = $settings_array['fastsheep_fstaf_input_bt'];
		$new_array['set_widget_shortcode_text'] = $settings_array['fastsheep_fstaf_input_wst'];
		$new_array['set_use_graphic_button'] = $settings_array['fastsheep_fstaf_input_ugb'];
		$new_array['set_graphic_button_url'] = $settings_array['fastsheep_fstaf_input_ugb_url'];

		$enc_string = serialize( $new_array );

		$update_where = array('meta_key' => 'settings_basic_user' );
		$update_result = $wpdb->update($table_name, array( 'meta_value' => $enc_string ), $update_where );

		if( $update_result === false ) { return false; }
		return true;
	}

	if( $fstaf_cat == 'settings_special_user' ) {

		$new_array = array();
		$new_array['set_lightbox_title'] = $settings_array['fastsheep_fstaf_input_mbt_s'];
		$new_array['set_email_subject'] = $settings_array['fastsheep_fstaf_input_es_s'];
		$new_array['set_button_text'] = $settings_array['fastsheep_fstaf_input_bt_s'];
		$new_array['set_widget_shortcode_text'] = $settings_array['fastsheep_fstaf_input_wst_s'];
		$new_array['set_use_graphic_button'] = $settings_array['fastsheep_fstaf_input_ugb_s'];
		$new_array['set_graphic_button_url'] = $settings_array['fastsheep_fstaf_input_ugb_url_s'];

		if( !empty($settings_array['fastsheep_fstaf_input_surl']) ) {
		$new_array['set_special_url'] = $settings_array['fastsheep_fstaf_input_surl'];
		} else {
		$new_array['set_special_url'] = home_url();
		}

		$enc_string = serialize( $new_array );

		$update_where = array('meta_key' => 'settings_special_user' );
		$update_result = $wpdb->update( $table_name, array( 'meta_value' => $enc_string ), $update_where );

		if( $update_result === false ) { return false; }
		return true;

	}

	return false;
}


function fastsheep_fstaf_update_emcss( $fstaf_cat = '', $settings_array = '' ) {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	if( $fstaf_cat == 'email_tpl' ) {

		$new_email_template = $settings_array['fastsheep_fstaf_input_etpl'];

		$enc_string = $new_email_template;

		$update_where = array('meta_key' => 'email_basic_user_tpl' );
		$update_result = $wpdb->update( $table_name, array( 'meta_value' => $enc_string ), $update_where );

		if( $update_result === false ) { return false; }
		return true;
	}

	if( $fstaf_cat == 'l_css' ) {

		$new_l_css = $settings_array['fastsheep_fstaf_input_lcss'];
		$enc_string = $new_l_css ;

		$update_where = array('meta_key' => 'css_basic_user' );
		$update_result = $wpdb->update( $table_name, array( 'meta_value' => $enc_string ), $update_where );

		if( $update_result === false ) { return false; }
		return true;

	}

		return false;

}

function fastsheep_fstaf_get_default_basic_etpl() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$em_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='email_basic_default_tpl' ");
	if( $em_res == null ) { return false; }

	return $em_res->meta_value;
}

function fastsheep_fstaf_get_default_basic_lcss() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$lcss_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='css_basic_default' ");
	if( $lcss_res == null ) { return false; }

	return $lcss_res->meta_value;
}

function fastsheep_fstaf_get_default_basic_settings() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$basic_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='settings_basic_default' ");
	if( $basic_res == null ) { return false; }

	return json_encode ( unserialize( $basic_res->meta_value ) );

}

function fastsheep_fstaf_get_default_special_settings() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$special_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='settings_special_default' ");
	if( $special_res == null ) { return false; }

	return json_encode ( unserialize( $special_res->meta_value ) );

}


function fastsheep_fstaf_verify_captcha($fs_number1 = 0, $fs_operand = '+', $fs_number2 = 0, $fs_result = 0 ) {

	if( $fs_operand == '+' && ( ( $fs_number1 + $fs_number2 ) == $fs_result ) ) { return true; }
	if( $fs_operand == '-' && ( ( $fs_number1 - $fs_number2 ) == $fs_result ) ) { return true; }
	if( $fs_operand == 'x' && ( ( $fs_number1 * $fs_number2 ) == $fs_result ) ) { return true; }

	return false;

}

function fastsheep_fstaf_set_html_mail_content_type() {
    return 'text/html';
}
?>
