<?php
if ( ! defined( 'ABSPATH' ) ) exit;

add_filter( 'template_include', 'fastsheep_fstaf_page_template');

function fastsheep_fstaf_page_template( $template ) {

        if( stripos( $_SERVER['REQUEST_URI'], '/' . get_option('fastsheep_fstaf_manage_slug') ) !== FALSE  && is_user_logged_in() && current_user_can('update_plugins') ) {

            return plugin_dir_path( __FILE__ ) . 'fs-taf-management.php';

	}

	return $template;
}


function fastsheep_fstaf_enqueue_options_style() {

    wp_enqueue_style( 'fastsheep_fstaf_css_style', VLADFSTAF_PLUGIN_PATH_SLASH . 'css/fs-taf-style.css' );
    wp_enqueue_script( 'fastsheep_fstaf_flot_script', VLADFSTAF_PLUGIN_PATH_SLASH . 'js/flot/jquery.flot.min.js', array(), '1.0.0', true );
    wp_enqueue_script( 'fastsheep_fstaf_flot_resize_script', VLADFSTAF_PLUGIN_PATH_SLASH . 'js/flot/jquery.flot.resize.min.js', array(), '1.0.0', true );
    wp_enqueue_script( 'fastsheep_fstaf_flot_categories_script', VLADFSTAF_PLUGIN_PATH_SLASH . 'js/flot/jquery.flot.categories.min.js', array(), '1.0.0', true );
    wp_enqueue_script( 'fastsheep_fstaf_flot_tooltip_script', VLADFSTAF_PLUGIN_PATH_SLASH . 'js/flot/jquery.flot.tooltip.min.js', array(), '1.0.0', true );

}
add_action( 'admin_enqueue_scripts', 'fastsheep_fstaf_enqueue_options_style' );


function fastsheep_fstaf_update_stats() {

  global $wpdb;

  $fstaf_tzone = get_option('timezone_string');
  if( $fstaf_tzone != '' ) { date_default_timezone_set( $fstaf_tzone ); }

  $table_name = $wpdb->prefix . "fastsheep_fstaf_data";

  $obj_stats = new stdClass();

  $res = $wpdb->get_row("SELECT * FROM " . $table_name . " WHERE meta_key='emails_count_obj' ");
  $obj_stats = unserialize( $res->meta_value );

  $datekeyday = date( 'Y-m-d', time() );
  $datekeymonth = date( 'Y-m', time() );


	if ( property_exists( $obj_stats ,$datekeyday) ) {
	  $obj_stats->{$datekeyday} += 1;
	} else {
	  $obj_stats->{$datekeyday} = 1;
	}


	if ( property_exists( $obj_stats ,$datekeymonth) ) {
	$obj_stats->{$datekeymonth} += 1;
	} else {
	$obj_stats->{$datekeymonth} = 1;
	}

	$enc_string = serialize( $obj_stats );

	$update_where = array('meta_key' => 'emails_count_obj' );
	$update_result = $wpdb->update($table_name, array( 'meta_value' => $enc_string ), $update_where );

	$update_where = array('meta_key' => 'emails_count_obj_ut' );
	$update_result_ut = $wpdb->update($table_name, array( 'meta_value' => time() ), $update_where );

	if( $update_result === false || $update_result_ut === false ) { return false; }
	return true;

}

function fastsheep_fstaf_feed_email_template( $feed_array = array(), $page_url = '', $fstaf_friend_name = '', $fstaf_sender_name = '' ) {

	$email_template = fastsheep_fstaf_get_basic_user_etpl();

	$feed_array['fastsheep_fstaf_pageurl'] = $page_url;
	$feed_array['fastsheep_fstaf_friend_name'] = $fstaf_friend_name;
	$feed_array['fastsheep_fstaf_sender_name'] = $fstaf_sender_name;

 	foreach( $feed_array as $key => $val ) {

    $email_template = str_replace('{'.$key.'}',  $val, $email_template);

  }

return $email_template;

}

function fastsheep_fstaf_get_basic_user_etpl() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$emailtpl_user_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='email_basic_user_tpl' ");
	if( $emailtpl_user_res == null ) { return false; }

	return $emailtpl_user_res->meta_value;

}

function fastsheep_fstaf_get_user_lcss_style() {

	global $wpdb;
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$css_user_res = $wpdb->get_row("SELECT meta_value FROM " . $table_name . " WHERE meta_key='css_basic_user' ");
	if( $css_user_res == null ) { return false; }

	return '<style>' . "\n" . $css_user_res->meta_value . "\n" . '</style>';

}

function fastsheep_fstaf_getUserBasicSettingsData() {

	global $wpdb;

	$return_array = array();
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$res = $wpdb->get_row("SELECT *	FROM " . $table_name . " WHERE meta_key='settings_basic_user' ");
	$return_array = unserialize( $res->meta_value );

	return $return_array;
}

function fastsheep_fstaf_getUserSpecialSettingsData() {

	global $wpdb;

	$return_array = array();
	$table_name = $wpdb->prefix . "fastsheep_fstaf_data";

	$res = $wpdb->get_row("SELECT *	FROM " . $table_name . " WHERE meta_key='settings_special_user' ");
	$return_array = unserialize( $res->meta_value );

	return $return_array;
}

function fastsheep_fstaf_get_logo_url() {

	return VLADFSTAF_PLUGIN_PATH_SLASH . 'images/fastsheep-logo-small.png';

}

function fastsheep_fstaf_get_email_progressing_url() {

	return VLADFSTAF_PLUGIN_PATH_SLASH . 'images/send-email-processing.gif';

}

function fastsheep_fstaf_get_rnd_string_length( $lg = 10 ){

	return substr( sha1(microtime(true).mt_rand(10000,90000)) ,0, $lg );
}

?>
